Models/DataMock.cs
using System;
using System.Collections.Generic;

using WebAppStudentMVC.Models;

namespace WebAppStudentMVC.Models
{
    public static class DataMock
    {
        public static List<Student> Students = new List<Student>() {
            new Student() { StartDate = new DateTime(2020, 05, 05), FirstName = "Gustavo", LastName = "Rebolledo",
                            Address = "Carrera #123", Dni = "11.111.111-1",
                            Email = "gustavo.rebolledo@virginiogomez.cl", Carrear = "Analista Programador", StateStudent = State.RegularStudent },
            new Student() { StartDate = new DateTime(2020, 05, 05), FirstName = "Gustavo", LastName = "Rebolledo",
                            Address = "Carrera #123", Dni = "11.111.111-1",
                            Email = "gustavo.rebolledo@virginiogomez.cl", Carrear = "Analista Programador", StateStudent = State.Graduated  },
            new Student() { StartDate = new DateTime(2020, 05, 05), FirstName = "Gustavo", LastName = "Rebolledo",
                            Address = "Carrera #123", Dni = "11.111.111-1",
                            Email = "gustavo.rebolledo@virginiogomez.cl", Carrear = "Analista Programador", StateStudent = State.Graduated  },
            new Student() { StartDate = new DateTime(2020, 05, 05), FirstName = "Gustavo", LastName = "Rebolledo",
                            Address = "Carrera #123", Dni = "11.111.111-1",
                            Email = "gustavo.rebolledo@virginiogomez.cl", Carrear = "Analista Programador", StateStudent = State.RegularStudent  }
        };

        public static bool AddStudent(Student student)
        {
            try
            {
                Students.Add(student);
                return true;
            }
            catch(Exception ex)
            {
                return false;
            }
        }
    }
}

Models/ErrorViewModel.cs
using System;

namespace WebAppStudentMVC.Models
{
    public class ErrorViewModel
    {
        public string RequestId { get; set; }

        public bool ShowRequestId => !string.IsNullOrEmpty(RequestId);
    }
}

Models/Student.cs
using System;

namespace WebAppStudentMVC.Models
{
    public class Student
    {
        public string FirstName { get; set; }
        public string LastName { get; set; }
        public string Dni { get; set; }
        public string Address { get; set; }
        public string Carrear { get; set; }
        public string Email { get; set; }
        public DateTime StartDate { get; set; }
        public string StateStudent { get; set; }
    }

    public static class State
    {
        public const string RegularStudent = "Alumno Regular", Graduated = "Titulado";
    }
}

Models/ViewModels/StudentViewModel.cs
using System.Collections.Generic;

namespace WebAppStudentMVC.Models.ViewModels
{
    public class StudentViewModel
    {
        public List<Student> Students { get; set; }

        public int StudentCount { get; set; }

    }
}

Controllers/HomeController.cs
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using WebAppStudentMVC.Models;

namespace WebAppStudentMVC.Controllers
{
    public class HomeController : Controller
    {
        private readonly ILogger<HomeController> _logger;

        public HomeController(ILogger<HomeController> logger)
        {
            _logger = logger;
        }

        public IActionResult Index()
        {
            return View();
        }

        public IActionResult Privacy()
        {
            return View();
        }

        [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
        public IActionResult Error()
        {
            return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
        }
    }
}

Controllers/StudentController.cs
using Microsoft.AspNetCore.Mvc;
using System.Collections.Generic;
using System;
using System.Linq;


using WebAppStudentMVC.Models.ViewModels;
using WebAppStudentMVC.Models;

namespace WebAppStudentMVC.Controllers
{
    public class StudentController : Controller
    {
        public IActionResult Index()
        {
            return RedirectToAction("RegularStudent");
        }

        public IActionResult RegularStudent() 
        {
            ViewData["title"] = "Lista de estudiantes regulares";

            StudentViewModel viewModel = new StudentViewModel();

            List<Student> regularStudent = DataMock.Students
                .Where(i => i.StateStudent.Equals(State.RegularStudent)).ToList();

            viewModel.Students = regularStudent;
            viewModel.StudentCount = regularStudent.Count;

            return View("Index", viewModel);
        }

        public IActionResult GraduatedStudent()
        {
            ViewData["title"] = "Lista de estudiantes titulados";
            StudentViewModel viewModel = new StudentViewModel();
            //forma 1 -> por for
            List<Student> graduatedStudent = new List<Student>();

            //foreach (Student s in DataMock.Students)
            //{
            //    if (s.StateStudent.Equals(State.Graduated))
            //    {
            //        graduatedStudent.Add(s);
            //    }
            //}

            //forma 2 -> por Linq
            graduatedStudent = DataMock.Students.Where(i => i.StateStudent.Equals(State.Graduated)).ToList();
            viewModel.Students = graduatedStudent;
            viewModel.StudentCount = graduatedStudent.Count;

            return View(viewModel);
        }
    }

}

Views/Home/Index.cshtml
@{
    ViewData["Title"] = "Home Page";
}

<div class="text-center">
    <h1 class="display-4">Welcome</h1>
    <p>Learn about <a href="https://docs.microsoft.com/aspnet/core">building Web apps with ASP.NET Core</a>.</p>
</div>

Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - WebAppStudentMVC</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" href="~/css/site.css" />
</head>
<body>
    <header>
        <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-light bg-white border-bottom box-shadow mb-3">
            <div class="container">
                <a class="navbar-brand" asp-area="" asp-controller="Home" asp-action="Index">WebAppStudentMVC</a>
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                        aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="navbar-collapse collapse d-sm-inline-flex justify-content-between">
                    <ul class="navbar-nav flex-grow-1">
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Student" asp-action="RegularStudent">Estudiantes regulares</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Student" asp-action="GraduatedStudent">Estudiantes graduados</a>
                        </li>
                    </ul>
                </div>
            </div>
        </nav>
    </header>
    <div class="container">
        <main role="main" class="pb-3">
            @RenderBody()
        </main>
    </div>

    <footer class="border-top footer text-muted">
        <div class="container">
            &copy; 2022 - WebAppStudentMVC - <a asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
        </div>
    </footer>
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    @await RenderSectionAsync("Scripts", required: false)
</body>
</html>

Views/Student/GraduatedStudent.cshtml
@*
    For more information on enabling MVC for empty projects, visit https://go.microsoft.com/fwlink/?LinkID=397860
*@
@{
}
@model WebAppStudentMVC.Models.ViewModels.StudentViewModel

<h1 class="display-5 m-5">@ViewData["title"]</h1>

<div class="container">
    <!-- validar que la lista tenga dato -->
    @if( Model.Students.Count == 0)
    {
        <div class="alert alert-info">
            ¡No existen datos para mostrar!
        </div>
    } else {
        <table class="table table-hover">
            <thead class="thead-light">
                <tr >
                <th>Nombre completo</th>
                <th>Rut</th>
                <th>Dirección</th>
                <th>Carrera</th>
                <th>Email</th>
                <th>Fecha matricula</th>
                <th>Estado alumno</th>
            </tr>
            </thead>
            <tbody>
                @foreach( Student student in Model.Students )
                {
                    <tr>
                        <td>@student.FirstName @student.LastName</td>
                        <td>@student.Dni</td>
                        <td>@student.Address</td>
                        <td>@student.Carrear</td>
                        <td>@student.Email</td>
                        <td>@student.StartDate.ToShortDateString()</td>
                        <td>@student.StateStudent</td>
                    </tr> 
                }
            </tbody>
            
        </table>
        <div class="text-right">
            Cantidad de alumnos titulados: @Model.StudentCount
        </div>
    }
</div>

Views/Student/Index.cshtml
@{

}

@model WebAppStudentMVC.Models.ViewModels.StudentViewModel

<h1 class="display-5 m-5">@ViewData["title"]!!</h1>

<div class="container">
    <!-- validar que la lista tenga dato -->
    @if( Model.Students.Count == 0)
    {
        <div class="alert alert-info">
            ¡No existen datos para mostrar!
        </div>
    } else {
        <table class="table table-hover">
            <thead class="thead-light">
                <tr >
                <th>Nombre completo</th>
                <th>Rut</th>
                <th>Dirección</th>
                <th>Carrera</th>
                <th>Email</th>
                <th>Fecha matricula</th>
                <th>Estado alumno</th>
            </tr>
            </thead>
            <tbody>
                @foreach( Student student in Model.Students )
                {
                    <tr>
                        <td>@student.FirstName @student.LastName</td>
                        <td>@student.Dni</td>
                        <td>@student.Address</td>
                        <td>@student.Carrear</td>
                        <td>@student.Email</td>
                        <td>@student.StartDate.ToShortDateString()</td>
                        <td>@student.StateStudent</td>
                    </tr> 
                }
            </tbody>
            
        </table>
        <div class="text-right">
            Cantidad de alumnos regulares: @Model.StudentCount
        </div>
    }
</div>